Object.defineProperty(exports, "__esModule", { value: true });
exports.System = void 0;
var tslib_1 = require("tslib");
var core_1 = require("@sentry/core");
var crossPlatform_1 = require("../crossPlatform");
var version_1 = require("../version");
/** UserAgent */
var System = /** @class */ (function () {
    function System() {
        /**
         * @inheritDoc
         */
        this.name = System.id;
    }
    /**
     * @inheritDoc
     */
    System.prototype.setupOnce = function () {
        var _this = this;
        core_1.addGlobalEventProcessor(function (event) { return tslib_1.__awaiter(_this, void 0, void 0, function () {
            var systemInfo, batteryLevel, currentBattery, battery, brand, language, model, pixelRatio, platform, screenHeight, screenWidth, statusBarHeight, system, version, windowHeight, windowWidth, app, appName, fontSizeSetting, SDKVersion, _a, systemName, systemVersion, e_1;
            return tslib_1.__generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!core_1.getCurrentHub().getIntegration(System)) return [3 /*break*/, 4];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, crossPlatform_1.sdk.getSystemInfo()];
                    case 2:
                        systemInfo = _b.sent();
                        batteryLevel = systemInfo.batteryLevel, currentBattery = systemInfo.currentBattery, battery = systemInfo.battery, brand = systemInfo.brand, language = systemInfo.language, model = systemInfo.model, pixelRatio = systemInfo.pixelRatio, platform = systemInfo.platform, screenHeight = systemInfo.screenHeight, screenWidth = systemInfo.screenWidth, statusBarHeight = systemInfo.statusBarHeight, system = systemInfo.system, version = systemInfo.version, windowHeight = systemInfo.windowHeight, windowWidth = systemInfo.windowWidth, app = systemInfo.app, appName = systemInfo.appName, fontSizeSetting = systemInfo.fontSizeSetting;
                        SDKVersion = version_1.SDK_VERSION;
                        _a = tslib_1.__read(system.split(" "), 2), systemName = _a[0], systemVersion = _a[1];
                        return [2 /*return*/, tslib_1.__assign(tslib_1.__assign({}, event), { contexts: tslib_1.__assign(tslib_1.__assign({}, event.contexts), { device: {
                                        brand: brand,
                                        battery_level: batteryLevel || currentBattery || battery,
                                        model: model,
                                        screen_dpi: pixelRatio
                                    }, os: {
                                        name: systemName || system,
                                        version: systemVersion || system
                                    }, extra: tslib_1.__assign({ SDKVersion: SDKVersion,
                                        language: language,
                                        platform: platform,
                                        screenHeight: screenHeight,
                                        screenWidth: screenWidth,
                                        statusBarHeight: statusBarHeight,
                                        version: version,
                                        windowHeight: windowHeight,
                                        windowWidth: windowWidth,
                                        fontSizeSetting: fontSizeSetting, app: app || appName || crossPlatform_1.appName }, systemInfo) }) })];
                    case 3:
                        e_1 = _b.sent();
                        console.warn("sentry-uniapp get system info fail: " + e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, event];
                }
            });
        }); });
    };
    /**
     * @inheritDoc
     */
    System.id = "System";
    return System;
}());
exports.System = System;
//# sourceMappingURL=system.js.map