import { __assign, __awaiter, __generator, __read } from "tslib";
import { addGlobalEventProcessor, getCurrentHub } from "@sentry/core";
import { appName as currentAppName, sdk } from "../crossPlatform";
import { SDK_VERSION } from "../version";
/** UserAgent */
var System = /** @class */ (function () {
    function System() {
        /**
         * @inheritDoc
         */
        this.name = System.id;
    }
    /**
     * @inheritDoc
     */
    System.prototype.setupOnce = function () {
        var _this = this;
        addGlobalEventProcessor(function (event) { return __awaiter(_this, void 0, void 0, function () {
            var systemInfo, batteryLevel, currentBattery, battery, brand, language, model, pixelRatio, platform, screenHeight, screenWidth, statusBarHeight, system, version, windowHeight, windowWidth, app, appName, fontSizeSetting, SDKVersion, _a, systemName, systemVersion, e_1;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!getCurrentHub().getIntegration(System)) return [3 /*break*/, 4];
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, sdk.getSystemInfo()];
                    case 2:
                        systemInfo = _b.sent();
                        batteryLevel = systemInfo.batteryLevel, currentBattery = systemInfo.currentBattery, battery = systemInfo.battery, brand = systemInfo.brand, language = systemInfo.language, model = systemInfo.model, pixelRatio = systemInfo.pixelRatio, platform = systemInfo.platform, screenHeight = systemInfo.screenHeight, screenWidth = systemInfo.screenWidth, statusBarHeight = systemInfo.statusBarHeight, system = systemInfo.system, version = systemInfo.version, windowHeight = systemInfo.windowHeight, windowWidth = systemInfo.windowWidth, app = systemInfo.app, appName = systemInfo.appName, fontSizeSetting = systemInfo.fontSizeSetting;
                        SDKVersion = SDK_VERSION;
                        _a = __read(system.split(" "), 2), systemName = _a[0], systemVersion = _a[1];
                        return [2 /*return*/, __assign(__assign({}, event), { contexts: __assign(__assign({}, event.contexts), { device: {
                                        brand: brand,
                                        battery_level: batteryLevel || currentBattery || battery,
                                        model: model,
                                        screen_dpi: pixelRatio
                                    }, os: {
                                        name: systemName || system,
                                        version: systemVersion || system
                                    }, extra: __assign({ SDKVersion: SDKVersion,
                                        language: language,
                                        platform: platform,
                                        screenHeight: screenHeight,
                                        screenWidth: screenWidth,
                                        statusBarHeight: statusBarHeight,
                                        version: version,
                                        windowHeight: windowHeight,
                                        windowWidth: windowWidth,
                                        fontSizeSetting: fontSizeSetting, app: app || appName || currentAppName }, systemInfo) }) })];
                    case 3:
                        e_1 = _b.sent();
                        console.warn("sentry-uniapp get system info fail: " + e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, event];
                }
            });
        }); });
    };
    /**
     * @inheritDoc
     */
    System.id = "System";
    return System;
}());
export { System };
//# sourceMappingURL=system.js.map